---
title: Request
slug: Web/API/Request
tags:
  - API
  - Fetch
  - Fetch API
  - Interface
  - Networking
  - Reference
  - request
---
<div>{{APIRef("Fetch API")}}</div>

<p>The <strong><code>Request</code></strong> interface of the <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a> represents a resource request.</p>

<p>You can create a new <code>Request</code> object using the {{domxref("Request.Request","Request()")}} constructor, but you are more likely to encounter a <code>Request</code> object being returned as the result of another API operation, such as a service worker {{domxref("FetchEvent.request")}}.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("Request.Request","Request()")}}</dt>
 <dd>Creates a new <code>Request</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("Request.cache")}} {{readonlyInline}}</dt>
 <dd>Contains the cache mode of the request (e.g., <code>default</code>, <code>reload</code>, <code>no-cache</code>).</dd>
 <dt>{{domxref("Request.context")}} {{readonlyInline}} {{deprecated_inline()}}</dt>
 <dd>Contains the context of the request (e.g., <code>audio</code>, <code>image</code>, <code>iframe</code>, etc.)</dd>
 <dt>{{domxref("Request.credentials")}} {{readonlyInline}}</dt>
 <dd>Contains the credentials of the request (e.g., <code>omit</code>, <code>same-origin</code>, <code>include</code>). The default is <code>same-origin</code>.</dd>
 <dt>{{domxref("Request.destination")}} {{ReadOnlyInline}}</dt>
 <dd>Returns a string from the {{domxref("RequestDestination")}} enum describing the request's destination. This is a string indicating the type of content being requested.</dd>
 <dt>{{domxref("Request.headers")}} {{readonlyInline}}</dt>
 <dd>Contains the associated {{domxref("Headers")}} object of the request.</dd>
 <dt>{{domxref("Request.integrity")}} {{readonlyInline}}</dt>
 <dd>Contains the <a href="/en-US/docs/Web/Security/Subresource_Integrity">subresource integrity</a> value of the request (e.g., <code>sha256-BpfBw7ivV8q2jLiT13fxDYAe2tJllusRSZ273h2nFSE=</code>).</dd>
 <dt>{{domxref("Request.method")}} {{readonlyInline}}</dt>
 <dd>Contains the request's method (<code>GET</code>, <code>POST</code>, etc.)</dd>
 <dt>{{domxref("Request.mode")}} {{readonlyInline}}</dt>
 <dd>Contains the mode of the request (e.g., <code>cors</code>, <code>no-cors</code>, <code>same-origin</code>, <code>navigate</code>.)</dd>
 <dt>{{domxref("Request.redirect")}} {{readonlyinline}}</dt>
 <dd>Contains the mode for how redirects are handled. It may be one of <code>follow</code>, <code>error</code>, or <code>manual</code>.</dd>
 <dt>{{domxref("Request.referrer")}} {{readonlyInline}}</dt>
 <dd>Contains the referrer of the request (e.g., <code>client</code>).</dd>
 <dt>{{domxref("Request.referrerPolicy")}} {{readonlyInline}}</dt>
 <dd>Contains the referrer policy of the request (e.g., <code>no-referrer</code>).</dd>
 <dt>{{domxref("Request.url")}} {{readonlyInline}}</dt>
 <dd>Contains the URL of the request.</dd>
</dl>

<p><code>Request</code> implements {{domxref("Body")}}, so it also inherits the following properties:</p>

<dl>
 <dt>{{domxref("Body.body", "body")}} {{readonlyInline}}</dt>
 <dd>A simple getter used to expose a {{domxref("ReadableStream")}} of the body contents.</dd>
 <dt>{{domxref("Body.bodyUsed", "bodyUsed")}} {{readonlyInline}}</dt>
 <dd>Stores a {{domxref("Boolean")}} that declares whether the body has been used in a response yet.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("Request.clone()")}}</dt>
 <dd>Creates a copy of the current <code>Request</code> object.</dd>
</dl>

<p><code>Request</code> implements {{domxref("Body")}}, so it also has the following methods available to it:</p>

<dl>
 <dt>{{domxref("Body.arrayBuffer()")}}</dt>
 <dd>Returns a promise that resolves with an {{domxref("ArrayBuffer")}} representation of the request body.</dd>
 <dt>{{domxref("Body.blob()")}}</dt>
 <dd>Returns a promise that resolves with a {{domxref("Blob")}} representation of the request body.</dd>
 <dt>{{domxref("Body.formData()")}}</dt>
 <dd>Returns a promise that resolves with a {{domxref("FormData")}} representation of the request body.</dd>
 <dt>{{domxref("Body.json()")}}</dt>
 <dd>Returns a promise that resolves with a {{domxref("JSON")}} representation of the request body.</dd>
 <dt>{{domxref("Body.text()")}}</dt>
 <dd>Returns a promise that resolves with an {{domxref("USVString")}} (text) representation of the request body.</dd>
</dl>

<div class="note">
<p><strong>Note</strong>: The {{domxref("Body")}} functions can be run only once; subsequent calls will resolve with empty strings/ArrayBuffers.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>In the following snippet, we create a new request using the <code>Request()</code> constructor (for an image file in the same directory as the script), then return some property values of the request:</p>

<pre class="brush: js notranslate">const request = new Request('https://www.mozilla.org/favicon.ico');

const url = request.url;
const method = request.method;
const credentials = request.credentials;
</pre>

<p>You could then fetch this request by passing the <code>Request</code> object in as a parameter to a {{domxref("WindowOrWorkerGlobalScope.fetch()")}} call, for example:</p>

<pre class="brush: js notranslate">fetch(request)
  .then(response =&gt; response.blob())
  .then(blob =&gt; {
    image.src = URL.createObjectURL(blob);
  });</pre>

<p>In the following snippet, we create a new request using the <code>Request()</code> constructor with some initial data and body content for an api request which need a body payload:</p>

<pre class="brush: js notranslate">const request = new Request('https://example.com', {method: 'POST', body: '{"foo": "bar"}'});

const url = request.url;
const method = request.method;
const credentials = request.credentials;
const bodyUsed = request.bodyUsed;
</pre>

<div class="note">
<p><strong>Note:</strong> The body type can only be a {{domxref("Blob")}}, {{domxref("BufferSource")}}, {{domxref("FormData")}}, {{domxref("URLSearchParams")}}, {{domxref("USVString")}} or {{domxref("ReadableStream")}} type, so for adding a JSON object to the payload you need to stringify that object.</p>
</div>

<p>You could then fetch this api request by passing the <code>Request</code> object in as a parameter to a {{domxref("WindowOrWorkerGlobalScope.fetch()")}} call, for example and get the response:</p>

<pre class="brush: js notranslate">fetch(request)
  .then(response =&gt; {
    if (response.status === 200) {
      return response.json();
    } else {
      throw new Error('Something went wrong on api server!');
    }
  })
  .then(response =&gt; {
    console.debug(response);
    // ...
  }).catch(error =&gt; {
    console.error(error);
  });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Fetch','#request-class','Request')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Request")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
